/**
 * Created by koroandr on 06.09.16.
 */
"use strict";
var RpcRequest = (function () {
    function RpcRequest(method, params) {
        this.method = method;
        this.params = params;
        this.id = "" + new Date().getTime() + Math.floor(Math.random() * 10000);
    }
    RpcRequest.prototype.serialize = function () {
        return JSON.stringify({
            jsonrpc: "2.0",
            id: this.id,
            method: this.method,
            params: this.params
        });
    };
    return RpcRequest;
}());
exports.RpcRequest = RpcRequest;
var RpcResponse = (function () {
    function RpcResponse(data) {
        var json = JSON.parse(data);
        this.id = json.id;
        if (json.error) {
            this.error = json.error;
        }
        else {
            this.result = json.result;
        }
    }
    return RpcResponse;
}());
exports.RpcResponse = RpcResponse;
