import {RpcError} from "./Rpc";
import Connector from "./Connector";
/**
 * Created by koroandr on 05.09.16.
 */

export class Client {
    constructor(url: string, private connections: number = 1) {
        for (let i = 0; i < connections; i++) {
            this.connectors.push(new Connector(url));
        }
    }

    send<TParams, TResult>(method: string, params: TParams, cb: RpcCallback<TResult>) {
        this.connectors[this.current_index++ % this.connections].addRequest(method, params, cb);
    }

    private connectors: Connector[] = [];

    private current_index = 0;
}

export type RpcCallback<TResult> = (result: TResult, err?: RpcError)=>void;
