/**
 * Created by koroandr on 06.09.16.
 */

export class RpcRequest {
    constructor(private method: string, private params: any) {
        this.id = `${new Date().getTime()}${Math.floor(Math.random() * 10000)}`;
    }

    serialize(): string {
        return JSON.stringify({
            jsonrpc: "2.0",
            id: this.id,
            method: this.method,
            params: this.params
        });
    }

    public id: string;
}

export class RpcResponse<T> {
    constructor(data: string) {
        let json = JSON.parse(data);

        this.id = json.id;

        if (json.error) {
            this.error = json.error;
        } else {
            this.result = json.result;
        }
    }

    public id: string;
    public result: T;
    public error: RpcError;
}

export interface RpcError {
    code: string | number;
    message: string;
    data?: any;
}
